<?php
/**
*
* DM Easy Dwonload System
*
* @package main
* @version $Id: download.php 213 2011-12-21 07:12:48Z femu $
* @copyright (c) 2009 femu - http://die-muellers.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/message_parser.' . $phpEx);

/**
* Some mod related variables and includes
*/
$dm_eds_path = (defined('DM_EDS_ROOT_PATH')) ? DM_EDS_ROOT_PATH : 'dm_eds/';
$dm_eds_file_path = (defined('DM_EDS_FILE_PATH')) ? DM_EDS_FILE_PATH : 'files/';

/**
* Do the session handling
*/
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/dm_eds');

/**
* Main work here
*/
$id	= request_var('id', 0, true);
$back_link = append_sid("{$phpbb_root_path}{$dm_eds_path}index.$phpEx");

if (defined('IN_ULTIMATE_POINTS') && $config['points_enable'])
{
	$sql = 'SELECT cost_per_dl, points_user_id
		FROM ' . DM_EDS_TABLE . '
		WHERE download_id = ' . (int) $id;
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$costs = $row['cost_per_dl'];
	$points_user_id = $row['points_user_id'];
	$db->sql_freeresult($result); 

	if (!$auth->acl_get('u_dm_eds_download'))
	{
		$message = $user->lang['EDS_NO_DOWNLOAD'] . '<br /><br /><a href="' . append_sid("{$phpbb_root_path}index.$phpEx") . '">&laquo; ' . $user->lang['EDS_BACK_INDEX'] . '</a>';
		trigger_error($message);
	}
	elseif ($user->data['user_id'] == ANONYMOUS && $costs > 0)
	{
		$message = $user->lang['EDS_REQUIRES_POINTS'] . '<br /><br /><a href="' . append_sid("{$phpbb_root_path}index.$phpEx") . '">&laquo; ' . $user->lang['EDS_BACK_INDEX'] . '</a>';
		trigger_error($message);
	}
	elseif ($user->data['user_id'] != ANONYMOUS && $costs > $user->data['user_points'])
	{
		$message = sprintf($user->lang['EDS_COST_ERROR'], $config['points_name']) . '<br /><br /><a href="' . append_sid("{$phpbb_root_path}index.$phpEx") . '">&laquo; ' . $user->lang['EDS_BACK_INDEX'] . '</a>';
		trigger_error($message);
	}
}

if ($id)
{
	$sql = 'SELECT d.*, c.*
		FROM ' . DM_EDS_TABLE . ' d
		LEFT JOIN ' . DM_EDS_CAT_TABLE . ' c
			ON d.download_cat_id = c.cat_id
		WHERE d.download_id = ' . (int) $id;
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);

	if (!$auth->acl_get('u_dm_eds_download'))
	{
		$message = $user->lang['EDS_NO_DOWNLOAD'] . '<br /><br /><a href="' . append_sid("{$phpbb_root_path}index.$phpEx") . '">&laquo; ' . $user->lang['EDS_BACK_INDEX'] . '</a>';
		trigger_error($message);
	}

	if (!$row)
	{
		trigger_error($user->lang['EDS_DL_NOEXISTS']);
	}

	$download_sub_path = $row['cat_sub_dir'];
	$download_filename = $row['download_filename'];
	$download_cost = $row['cost_per_dl'];

	$url = $phpbb_root_path . $dm_eds_file_path . $download_sub_path . '/' . $download_filename;

	$sql = 'UPDATE ' . DM_EDS_TABLE . '
		SET download_count = download_count + 1
		WHERE download_id = ' . $id;
	$result=$db->sql_query($sql);


	if (defined('IN_ULTIMATE_POINTS') && $config['points_enable'])
	{
		if (!function_exists('substract_points'))
		{
			includes($phpbb_root_path . 'includes/points/functions_points.' . $phpEx);
		}

		if ($download_cost > 0)
		{
			// Substract cash for deleting
			substract_points($user->data['user_id'], $download_cost);
		}

		if ($points_user_id > 0)
		{
			// Transfer cost to named user
			add_points($points_user_id, $download_cost);
		}
	}
	$db->sql_freeresult($result); 

	header('Content-type: application/octet-stream');
	header('Content-disposition: attachment; ' . header_filename(htmlspecialchars_decode($download_filename)));
	header('Content-Length: ' . filesize($url));
	readfile($url);
}
else
{
	trigger_error($user->lang['EDS_NO_ID']);
}

/**
* Get a browser friendly UTF-8 encoded filename
*/
function header_filename($file)
{
	$user_agent = (!empty($_SERVER['HTTP_USER_AGENT'])) ? htmlspecialchars((string) $_SERVER['HTTP_USER_AGENT']) : '';

	// There be dragons here.
	// Not many follows the RFC...
	if (strpos($user_agent, 'MSIE') !== false || strpos($user_agent, 'Safari') !== false || strpos($user_agent, 'Konqueror') !== false)
	{
		return "filename=" . rawurlencode($file);
	}

	// follow the RFC for extended filename for the rest
	return "filename*=UTF-8''" . rawurlencode($file);
}

?>