<?php
/**
*
* DM Easy Download System
*
* @package functions
* @version $Id: functions_dm_eds.php 213 2011-12-21 07:12:48Z femu $
* @copyright (c) 2009 femu - http://die-muellers.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* Some mod related variables
*/
$dm_eds_path = (defined('DM_EDS_ROOT_PATH')) ? DM_EDS_ROOT_PATH : 'dm_eds/';
$dm_eds_file_path = (defined('DM_EDS_FILE_PATH')) ? DM_EDS_FILE_PATH : 'dm_eds/files/';

/**
* Do the session handling
*/
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/dm_eds');

/**
* Template variables for the navigation
*/
$template->assign_block_vars('navlinks', array(
	'FORUM_NAME'	=> $user->lang['EDS_TITLE'],
	'U_VIEW_FORUM'	=> append_sid("{$phpbb_root_path}{$dm_eds_path}index.$phpEx"),
));

/**
* Returns cat parents as an array
*/
function get_cat_parents(&$cat_data)
{
	global $db;

	$cat_parents = array();
	if ($cat_data['parent_id'] > 0)
	{
		if ($cat_data['cat_parents'] == '')
		{
			$sql = 'SELECT cat_id, cat_name
				FROM ' . DM_EDS_CAT_TABLE . '
				WHERE left_id < ' . $cat_data['left_id'] . '
					AND right_id > ' . $cat_data['right_id'] . '
				ORDER BY left_id ASC';
			$result = $db->sql_query($sql);
			while ($row = $db->sql_fetchrow($result))
			{
				$row['cat_type'] = 1;
				$cat_parents[$row['cat_id']] = array($row['cat_name'], (int) $row['cat_type']);
			}
			$db->sql_freeresult($result);
			$cat_data['cat_parents'] = serialize($cat_parents);
			$sql = 'UPDATE ' . DM_EDS_CAT_TABLE . "
				SET cat_parents = '" . $db->sql_escape($cat_data['cat_parents']) . "'
				WHERE parent_id = " . $cat_data['parent_id'];
			$db->sql_query($sql);
		}
		else
		{
			return; //$cat_parents = unserialize($cat_data['cat_parents']);
		}
	}
	return $cat_parents;
}

/**
* Get the categories infos
*/
function get_cat_info($cat_id)
{
	global $db;

	$sql = 'SELECT *
		FROM ' . DM_EDS_CAT_TABLE . '
		WHERE cat_id = ' . $cat_id;
	$result = $db->sql_query($sql);

	while ($row = $db->sql_fetchrow($result))
	{
		$cat_data = $row;
	}
	return $cat_data;
}

/**
* Generate the navigation bar
*/
function generate_cat_nav(&$cat_data)
{
	global $db, $user, $template, $auth;
	global $phpEx, $phpbb_root_path, $dm_eds_path;

	// Get video parents
	$cat_parents = get_cat_parents($cat_data);

	// Build navigation links
	if (!empty($cat_parents))
	{
		foreach ($cat_parents as $parent_cat_id => $parent_data)
		{
			list($parent_name, $parent_type) = array_values($parent_data);
			$template->assign_block_vars('navlinks', array(
				'FORUM_NAME'	=> $parent_name,
				'U_VIEW_FORUM'	=> append_sid("{$phpbb_root_path}{$dm_eds_path}showcat.$phpEx", 'id=' . $parent_cat_id),
			));
		}
	}

	$template->assign_block_vars('navlinks', array(
		'FORUM_NAME'	=> $cat_data['cat_name'],
		'U_VIEW_FORUM'	=> append_sid("{$phpbb_root_path}{$dm_eds_path}showcat.$phpEx", 'id=' . $cat_data['cat_id']),
	));
	return;
}

/**
* Generate the sub categories list
*/
function generate_cat_list($cat_id)
{
	global $db, $template, $phpbb_root_path, $phpEx, $user, $config, $dm_eds_path, $dm_eds_file_path;

	$dm_eds_path = (defined('DM_EDS_ROOT_PATH')) ? DM_EDS_ROOT_PATH : 'dm_eds/';
	$dm_eds_file_path = (defined('DM_EDS_FILE_PATH')) ? DM_EDS_FILE_PATH : 'dm_eds/files/';

	$sql = 'SELECT bc.*, bd.*, COUNT(bd.download_id) AS number_downloads, MAX(bd.last_changed_time) AS last_download
		FROM ' . DM_EDS_CAT_TABLE . ' bc
		LEFT JOIN ' . DM_EDS_CAT_TABLE . ' bc2
			ON ( bc2.left_id < bc.right_id
				AND bc2.left_id > bc.left_id )
		LEFT JOIN ' . DM_EDS_TABLE . ' bd
			ON ( bd.download_cat_id = bc.cat_id
				OR bd.download_cat_id = bc2.cat_id )
		WHERE bc.parent_id = ' . $cat_id . '
		GROUP BY bc.cat_id
		ORDER BY bc.left_id ASC';
	$result = $db->sql_query($sql);

	while ($row = $db->sql_fetchrow($result))
	{
		$row['last_download'] = ($row['last_download']) ? $row['last_download'] : 0;
		$subcats = $last_download_id = $last_download_title = $last_download_chg_time = $last_download = $downloads = $download = $last_download_name = $download_version = $download_title = $download_count = $upload_time = $last_changed_time = '';

		// Do we have sub categories?
		if (($row['left_id'] + 1) != $row['right_id'])
		{
			$sql2 = 'SELECT bc.*
				FROM ' . DM_EDS_CAT_TABLE . ' bc
				WHERE bc.parent_id = ' . $row['cat_id'] . '
				ORDER BY bc.left_id ASC';
			$result2 = $db->sql_query($sql2);
			
			while ($row2 = $db->sql_fetchrow($result2))
			{
				$subcats .= ($subcats) ? ', ' : '';
				$subcats .= '<a class="subforum ' . (((isset($read_info[$row2['cat_id']]) ? $read_info[$row2['cat_id']] : 0) && ($user->data['user_id'] != ANONYMOUS)) ? 'unread' : 'read') . '" href="';
				$subcats .= append_sid("{$phpbb_root_path}{$dm_eds_path}showcat.$phpEx", 'id=' . $row2['cat_id']);
				$subcats .= '">' . censor_text($row2['cat_name']) . '</a>';
			}
			$db->sql_freeresult($result2);

			$folder_image = 'forum_read_subforum';
			$folder_alt = 'no';
			$l_subcats = $user->lang['EDS_SUB_CAT'];
			if ($row['left_id'] + 3 != $row['right_id'])
			{
				$l_subcats = $user->lang['EDS_SUB_CATS'];
			}
		}
		else
		{
			$folder_image = 'forum_read';
			$l_subcats = '';
			$folder_alt = 'no';
		}

		if ( $row['last_download'] )
		{
			$sql2 = 'SELECT *
				FROM ' . DM_EDS_TABLE . '
				WHERE last_changed_time = ' . $row['last_download'];
			$result2 = $db->sql_query($sql2);

			while ($row2 = $db->sql_fetchrow($result2))
			{
				$last_download_name = $row2['download_title'];
				$last_download_version = $row2['download_version'];
				$last_download_count = $row2['download_count'];
				$last_download_up_date = $row2['upload_time'];
				$last_download_chg_time = $user->format_date($row2['last_changed_time']);
			}
			
			if ( !empty($last_download_version) )
			{
				$downloads = $last_download_name . ' v' . $last_download_version;
			}
			else
			{
				$downloads = $last_download_name;
			}

			$last_download = sprintf($user->lang['EDS_LAST_DOWNLOAD'], $downloads, $last_download_count, $last_download_chg_time);
		}
		else
		{
			$last_download = $user->lang['EDS_NO_DOWNLOADS'];
		}
		
		// Send the results to the template
		$template->assign_block_vars('catrow', array(
			'LAST_DOWNLOAD'			=> $last_download,
			'NUMBER_DOWNLOADS'		=> $row['number_downloads'],
			'CAT_NAME'				=> censor_text($row['cat_name']),
			'U_EDS_CAT'				=> append_sid("{$phpbb_root_path}{$dm_eds_path}showcat.$phpEx", 'id=' . $row['cat_id']),
			'CAT_DESC'				=> generate_text_for_display($row['cat_desc'], $row['cat_desc_uid'], $row['cat_desc_bitfield'], $row['cat_desc_options']),
			'CAT_FOLDER_IMG_SRC'	=> $user->img($folder_image, $folder_alt, false, '', 'src'),
			'SUBCATS'				=> ($subcats) ? $l_subcats . ': <span style="font-weight: bold;">' . $subcats . '</span>' : '',
		));
	}
	$db->sql_freeresult($result);

	$template->assign_vars(array(
		'LAST_POST_IMG'	=> $user->img('icon_topic_latest', 'VIEW_LATEST_POST'),
	));
}

?>