<?php
/**
*
* DM Easy Download System
*
* @package main
* @version $Id: index.php 213 2011-12-21 07:12:48Z femu $
* @copyright (c) 2009 femu - http://die-muellers.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'dm_eds/includes/functions_dm_eds.' . $phpEx);
include($phpbb_root_path . 'includes/message_parser.' . $phpEx);

/**
* Some mod related variables
*/
$dm_eds_path = (defined('DM_EDS_ROOT_PATH')) ? DM_EDS_ROOT_PATH : 'dm_eds/';
$dm_eds_file_path = (defined('DM_EDS_FILE_PATH')) ? DM_EDS_FILE_PATH : 'dm_eds/files/';

/**
* Do the session handling
*/
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/dm_eds');

/**
* If the install folder is still present, inform the admin
*/
if (file_exists($phpbb_root_path . 'install_dm_eds.php'))
{
	// Adjust the message slightly according to the permissions
	if ( $auth->acl_gets('a_') )
	{
		$message = $user->lang['EDS_REMOVE_INSTALL'];
	}
	else
	{
		$message = $user->lang['EDS_DISABLED'];
	}
	trigger_error($message);
}

/**
* Check, if user may see the DM EDS
*/
if (!$auth->acl_get('u_dm_eds_use'))
{
		$message = $user->lang['EDS_NO_PERMISSION'] . '<br /><br /><a href="' . append_sid("{$phpbb_root_path}index.$phpEx") . '">&laquo; ' . $user->lang['EDS_BACK_INDEX'] . '</a>';
		trigger_error($message);
}

/**
* Create the category list
*/
$cat_id = 0;
generate_cat_list($cat_id);

/**
* The output of the page
*/
page_header($user->lang['EDS_TITLE'] . ' &bull; ' . $user->lang['EDS_INDEX']);

$template->set_filenames(array(
	'body' => $dm_eds_path . 'index_body.html'
));

page_footer();

?>