<?php
/**
*
* DM Easy Dwonlaod System
*
* @package main
* @version $Id: showcat.php 213 2011-12-21 07:12:48Z femu $
* @copyright (c) 2009 femu - http://die-muellers.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'dm_eds/includes/functions_dm_eds.' . $phpEx);
include($phpbb_root_path . 'includes/message_parser.' . $phpEx);

/**
* Some mod related variables
*/
$dm_eds_path = (defined('DM_EDS_ROOT_PATH')) ? DM_EDS_ROOT_PATH : 'dm_eds/';
$dm_eds_file_path = (defined('DM_EDS_FILE_PATH')) ? DM_EDS_FILE_PATH : 'dm_eds/files/';

/**
* Do the session handling
*/
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/dm_eds');

/**
* Read out config vlaues
*/
$sql = 'SELECT * 
	FROM ' . DM_EDS_CONFIG_TABLE;
$result = $db->sql_query($sql);
$eds_values = $db->sql_fetchrow($result);
$db->sql_freeresult($result);

$start	= request_var('start', 0);
$number	= $eds_values['pagination_user'];

/**
* Retrieve cat id
*/
$cat_id = request_var('id', 0);

/**
* We need some information about the cat, we are in
*/
// Select cat name
$sql = 'SELECT cat_name
	FROM ' . DM_EDS_CAT_TABLE . '
	WHERE cat_id = ' . $cat_id;
$result = $db->sql_query($sql);
$row = $db->sql_fetchrow($result);
$db->sql_freeresult($result);

if (!$row)
{
	$message = $user->lang['EDS_CAT_NOT_EXIST'] . '<br /><br /><a href="' . append_sid("{$phpbb_root_path}{$dm_eds_path}index.$phpEx") . '">&laquo; ' . $user->lang['EDS_BACK_DOWNLOADS'] . '</a>';
	trigger_error($message);
}
else
{
	$cat_data = get_cat_info($cat_id);
}

/**
* Generate the navigation
*/
generate_cat_nav($cat_data);

/**
* Create the download list
*/

// Check users points, if UPS is installed and active
if (defined('IN_ULTIMATE_POINTS') && $config['points_enable'])
{
	$sql = 'SELECT user_points
		FROM ' . USERS_TABLE . '
		WHERE user_id = ' . (int) $user->data['user_id'];
	$result = $db->sql_query($sql);
	$user_points = (int) $db->sql_fetchfield('user_points');
}

// Total number of downloads
$sql = 'SELECT COUNT(download_id) AS total_downloads
	FROM ' . DM_EDS_TABLE . '
	WHERE download_cat_id = ' . (int) $cat_id;
$result = $db->sql_query($sql);
$row = $db->sql_fetchrow($result);
$total_downloads = $row['total_downloads'];
$db->sql_freeresult($result);

// Select cat name
$sql = 'SELECT cat_name
	FROM ' . DM_EDS_CAT_TABLE . '
	WHERE cat_id = ' . (int) $cat_id;
$result = $db->sql_query($sql);
$row = $db->sql_fetchrow($result);
$cat_name = $row['cat_name'];
$db->sql_freeresult($result);

// Check if there are downloads
if ($total_downloads == 0)
{
	$template->assign_vars(array(
		'CAT_NAME'		=> $cat_name,
		'S_NO_FILES'	=> true,
		'MAIN_LINK'		=> append_sid("{$phpbb_root_path}{$dm_eds_path}index.$phpEx"),
		'U_BACK'		=> append_sid("{$phpbb_root_path}index.$phpEx"),
	));
}
else
{
	// List the downloads in current category
	$theme_path = '';
	$theme_path = "{$phpbb_root_path}styles/" . $user->theme['theme_path'] . '/theme/images/';

	$sql = 'SELECT d.*, c.*
		FROM ' . DM_EDS_TABLE . ' d
			LEFT JOIN ' . DM_EDS_CAT_TABLE . ' c
			ON d.download_cat_id = c.cat_id
		WHERE c.cat_id = ' . (int) $cat_id . '
		ORDER BY LOWER(d.download_title)';
	$result = $db->sql_query_limit($sql, $number, $start);

	while ($row = $db->sql_fetchrow($result))
	{
		$dl_id				= $row['download_id'];
		$dl_title			= $row['download_title'];
		$dl_version			= $row['download_version'];
		$dl_clicks  		= $row['download_count'];
		$cat_name 			= $row['cat_name'];
		$upload_time 		= $row['upload_time'];
		$last_changed_time 	= $row['last_changed_time'];
		$filesize  			= $row['filesize'] > 1048576 ? round($row['filesize']/1048576, 2) . ' MB' : round($row['filesize']/1024) . ' kB';

		if (defined('IN_ULTIMATE_POINTS') && $config['points_enable'])
		{
			$user->setup('mods/points');
			$dl_cost = ($row['cost_per_dl'] == 0 ? $user->lang['EDS_FREE'] : number_format_points($row['cost_per_dl']));

			if (!$auth->acl_get('u_dm_eds_download'))
			{
				$download = '<img src="'. $theme_path . 'eds_no_download.png" title="' . sprintf($user->lang['EDS_NO_DOWNLOAD']) . '" alt=""></img>';
			}
			elseif ($row['cost_per_dl'] > 0 && $user->data['user_points'] < $row['cost_per_dl'])
			{
				$download = '<img src="'. $theme_path . 'eds_no_download.png" title="' . sprintf($user->lang['EDS_COST_ERROR'], $config['points_name']) . '" alt=""></img>';
			}
			elseif ($row['cost_per_dl'] == 0 && $auth->acl_get('u_dm_eds_download'))
			{
				$download = '<a href="' . append_sid("{$phpbb_root_path}{$dm_eds_path}download.$phpEx?id=$dl_id") . '" ><img src="' . $theme_path . 'eds_free_download.png" title="' . sprintf($user->lang['EDS_COST_FREE'], $config['points_name']) . '" alt=""></img></a>';
			}
			elseif ($auth->acl_get('u_dm_eds_download'))
			{
				$download = '<a href="' . append_sid("{$phpbb_root_path}{$dm_eds_path}download.$phpEx?id=$dl_id") . '" ><img src="' . $theme_path . 'eds_download.png" title="' . sprintf($user->lang['EDS_COST_OK'], $config['points_name']) . '" alt=""></img></a>';
			}

			$template->assign_block_vars('catrow', array(
				'S_UPS_EXIST'		=> true,
				'DL_COST'			=> $dl_cost,
				'POINTS_NAME'		=> $config['points_name'],
				'U_DOWNLOAD'		=> $download,
				'DL_TITLE'			=> $dl_title,
				'DL_VERSION'		=> $dl_version,
				'DL_CLICKS'			=> $dl_clicks,
				'DL_DESC'			=> generate_text_for_display($row['download_desc'], $row['bbcode_uid'], $row['bbcode_bitfield'], $row['bbcode_options']),
				'DL_UPLOAD_TIME' 	=> $user->format_date($upload_time),
				'DL_LAST_CHANGED' 	=> $user->format_date($last_changed_time),
				'DL_FILESIZE'		=> $filesize,
			));
		}
		elseif (!defined('IN_ULTIMATE_POINTS') || !$config['points_enable'])
		{
			$dl_cost = ($row['cost_per_dl'] == 0 ? $user->lang['EDS_FREE'] : sprintf(number_format($row['cost_per_dl'])));
			if (!$auth->acl_get('u_dm_eds_download'))
			{
				$download = '<img src="'. $theme_path . 'eds_no_download.png" title="' . sprintf($user->lang['EDS_NO_PERMISSION']) . '" alt=""></img>';
			}
			else
			{
				$download = '<a href="' . append_sid("{$phpbb_root_path}{$dm_eds_path}download.$phpEx?id=$dl_id") . '"><img src="' . $theme_path . 'eds_regular_download.png" title="' . $user->lang['EDS_REGULAR_DOWNLOAD'] . '" alt=""></img></a>';
			}

			$template->assign_block_vars('catrow', array(
				'DL_TITLE'			=> $dl_title,
				'DL_VERSION'		=> $dl_version,
				'DL_CLICKS'			=> $dl_clicks,
				'DL_DESC'			=> generate_text_for_display($row['download_desc'], $row['bbcode_uid'], $row['bbcode_bitfield'], $row['bbcode_options']),
				'DL_UPLOAD_TIME' 	=> $user->format_date($upload_time),
				'DL_LAST_CHANGED' 	=> $user->format_date($last_changed_time),
				'DL_FILESIZE'		=> $filesize,
				'U_DOWNLOAD'		=> $download,
			));
		}
	}

	$db->sql_freeresult($result);

	if (defined('IN_ULTIMATE_POINTS') && $config['points_enable'])
	{
		if (!$auth->acl_get('u_dm_eds_download'))
		{
			$template->assign_vars(array(
				'S_UPS_EXIST' 		=> true,
				'EDS_LEGEND_OK'		=> sprintf($user->lang['EDS_LEGEND_OK'], $config['points_name']),
				'EDS_LEGEND_ERROR'	=> sprintf($user->lang['EDS_LEGEND_NO_DL']),
			));
		}
		else
		{
			$template->assign_vars(array(
				'S_UPS_EXIST' 		=> true,
				'EDS_LEGEND_OK'		=> sprintf($user->lang['EDS_LEGEND_OK'], $config['points_name']),
				'EDS_LEGEND_ERROR'	=> sprintf($user->lang['EDS_LEGEND_ERROR'], $config['points_name']),
			));
		}
	}

	$template->assign_vars(array(
		'CAT_NAME' 			=> $cat_name,
		'MAIN_LINK'			=> append_sid("{$phpbb_root_path}{$dm_eds_path}index.$phpEx"),
		'PAGINATION' 		=> generate_pagination(append_sid("{$phpbb_root_path}{$dm_eds_path}showcat.$phpEx?id=$cat_id"), $total_downloads, $number, $start, true),
		'PAGE_NUMBER'		=> on_page($total_downloads, $number, $start),
		'TOTAL_DOWNLOADS'	=> ($total_downloads == 1) ? $user->lang['EDS_SINGLE'] : sprintf($user->lang['EDS_MULTI'], $total_downloads),
		'L_MAIN_LINK'		=> sprintf($user->lang['EDS_BACK_LINK'], '<a href= "' . append_sid("{$phpbb_root_path}{$dm_eds_path}index.$phpEx") . '">', '</a>'),
	));
}

/**
* The output of the page
*/
page_header($user->lang['EDS_TITLE'] . ' &bull; ' . $cat_name);

$template->set_filenames(array(
	'body' => $dm_eds_path . 'showcat_body.html'
));

page_footer();

?>